package hatenahaiku4j;

import hatenahaiku4j.util.DateUtil;
import hatenahaiku4j.util.HttpUtil;
import hatenahaiku4j.util.XmlUtil;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * ͂ĂȃnCNAPIbsONXiF؂Ȃj
 * 
 * @see <a href="http://h.hatena.ne.jp/api">͂ĂȃnCNAPI</a>
 * @author fumokmm
 */
public class HatenaHaikuAPIWithoutAuth {
	/** URL: pubN^CC(XML) */
	protected static final String URL_PUBLIC_TIMELINE_XML		= "http://h.hatena.ne.jp/api/statuses/public_timeline.xml";
	/** URL: th^CC */
	protected static final String URL_FRIENDS_TIMELINE			= "http://h.hatena.ne.jp/api/statuses/friends_timeline/";
	/** URL: [U^CC */
	protected static final String URL_USER_TIMELINE				= "http://h.hatena.ne.jp/api/statuses/user_timeline/";
	/** URL: L[[h^CC */
	protected static final String URL_KEYWORD_TIMELINE			= "http://h.hatena.ne.jp/api/statuses/keyword_timeline/";
	/** URL: Ao^CC(XML) */
	protected static final String URL_ALBUM_TIMELINE_XML		= "http://h.hatena.ne.jp/api/statuses/album.xml";
	/** URL: L[[h^CC */
	protected static final String URL_ALBUM_TIMELINE			= "http://h.hatena.ne.jp/api/statuses/album/";
	/** URL: Xe[^X */
	protected static final String URL_STATUS					= "http://h.hatena.ne.jp/api/statuses/show/";
	/** URL: [UtH[Ă郆[ŨXg */
	protected static final String URL_FOLLOWING_LIST			= "http://h.hatena.ne.jp/api/statuses/friends/";
	/** URL: [UtH[Ă郆[ŨXg */
	protected static final String URL_FOLLOWERS_LIST			= "http://h.hatena.ne.jp/api/statuses/followers/";
	/** URL: [U */
	protected static final String URL_USER						= "http://h.hatena.ne.jp/api/friendships/show/";
	/** URL: zbgL[[h̃Xg(XML) */
	protected static final String URL_HOT_KEYWORD_LIST_XML		= "http://h.hatena.ne.jp/api/keywords/hot.xml";
	/** URL: L[[h̃Xg(XML) */
	protected static final String URL_KEYWORD_LIST_XML			= "http://h.hatena.ne.jp/api/keywords/list.xml";
	/** URL: [UtH[ĂL[[h̃Xg */
	protected static final String URL_FOLLOWING_KEYWORD_LIST	= "http://h.hatena.ne.jp/api/statuses/keywords/";
	/** URL: L[[h */
	protected static final String URL_KEYWORD					= "http://h.hatena.ne.jp/api/keywords/show/";

	/**
	 * RXgN^B
	 */
	public HatenaHaikuAPIWithoutAuth() {}
	
	//-------------------------------------------------------------
	// ^CC֌W
	//-------------------------------------------------------------

	/**
	 * pubN^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/public_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/">͂ĂȃnCN</a>
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-public_timeline">statuses/public_timeline</a>
	 * @return pubN^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getPublicTimeline() throws HatenaHaikuException {
		return getPublicTimeline(0, 0, null);
	}

	/**
	 * pubN^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/public_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/">͂ĂȃnCN</a>
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-public_timeline">statuses/public_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @return pubN^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getPublicTimeline(int page) throws HatenaHaikuException {
		return getPublicTimeline(page, 0, null);
	}
	/**
	 * pubN^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/public_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/">͂ĂȃnCN</a>
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-public_timeline">statuses/public_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return pubN^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getPublicTimeline(int page, int count) throws HatenaHaikuException {
		return getPublicTimeline(page, count, null);
	}
	/**
	 * pubN^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/public_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/">͂ĂȃnCN</a>
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-public_timeline">statuses/public_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return pubN^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getPublicTimeline(int page, int count, Date since) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(URL_PUBLIC_TIMELINE_XML, param);
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * w肵[Ũth^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @param userId [UID
	 * @return w肵[Ũth^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getFriendsTimeline(String userId) throws HatenaHaikuException {
		return getFriendsTimeline(userId, 0, 0, null);
	}

	/**
	 * w肵[Ũth^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @param userId [UID
	 * @param page 擾y[WłBő吔100łB
	 * @return w肵[Ũth^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getFriendsTimeline(String userId, int page) throws HatenaHaikuException {
		return getFriendsTimeline(userId, page, 0, null);
	}

	/**
	 * w肵[Ũth^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @param userId [UID
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return w肵[Ũth^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getFriendsTimeline(String userId, int page, int count) throws HatenaHaikuException {
		return getFriendsTimeline(userId, page, count, null);
	}

	/**
	 * w肵[Ũth^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @param userId [UID
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return w肵[Ũth^CC
	 * @throws HatenaHaikuException 
	 */
	public List<Status> getFriendsTimeline(String userId, int page, int count, Date since) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(URL_FRIENDS_TIMELINE + userId + Const.EXT_XML, param);
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	/**
	 * w肵[Ũ[U^CC擾܂BŐVy[W20擾܂B<br/>
	 *@<i>http://h.hatena.ne.jp/api/statuses/user_timeline/<font color="red">[UID</font>.xml</i>
	 *
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param userId [UID
	 * @return w肵[Ũ[U^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getUserTimeline(String userId) throws HatenaHaikuException {
		return getUserTimeline(userId, 0, 0, null);
	}

	/**
	 * w肵[Ũ[U^CC擾܂B擾20łB<br/>
	 *@<i>http://h.hatena.ne.jp/api/statuses/user_timeline/<font color="red">[UID</font>.xml</i>
	 *
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param userId [UID
	 * @param page 擾y[WłBő吔100łB
	 * @return w肵[Ũ[U^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getUserTimeline(String userId, int page) throws HatenaHaikuException {
		return getUserTimeline(userId, page, 0, null);
	}

	/**
	 * w肵[Ũ[U^CC擾܂B<br/>
	 *@<i>http://h.hatena.ne.jp/api/statuses/user_timeline/<font color="red">[UID</font>.xml</i>
	 *
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param userId [UID
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return w肵[Ũ[U^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getUserTimeline(String userId, int page, int count) throws HatenaHaikuException {
		return getUserTimeline(userId, page, count, null);
	}

	/**
	 * w肵[Ũ[U^CC擾܂B<br/>
	 *@<i>http://h.hatena.ne.jp/api/statuses/user_timeline/<font color="red">[UID</font>.xml</i>
	 *
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param userId [UID
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return w肵[Ũ[U^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getUserTimeline(String userId, int page, int count, Date since) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(URL_USER_TIMELINE + userId + Const.EXT_XML, param);
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	/**
	 * w肵L[[h̃L[[h^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/keyword_timeline/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-keyword_timeline">statuses/keyword_timeline</a>
	 * @param keyword L[[h
	 * @return w肵L[[h̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getKeywordTimeline(String keyword) throws HatenaHaikuException {
		return getKeywordTimeline(keyword, 0, 0, null);
	}

	/**
	 * w肵L[[h̃L[[h^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/keyword_timeline/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-keyword_timeline">statuses/keyword_timeline</a>
	 * @param keyword L[[h
	 * @param page 擾y[WłBő吔100łB
	 * @return w肵L[[h̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getKeywordTimeline(String keyword, int page) throws HatenaHaikuException {
		return getKeywordTimeline(keyword, page, 0, null);
	}

	/**
	 * w肵L[[h̃L[[h^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/keyword_timeline/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-keyword_timeline">statuses/keyword_timeline</a>
	 * @param keyword L[[h
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return w肵L[[h̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getKeywordTimeline(String keyword, int page, int count) throws HatenaHaikuException {
		return getKeywordTimeline(keyword, page, count, null);
	}

	/**
	 * w肵L[[h̃L[[h^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/keyword_timeline/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-keyword_timeline">statuses/keyword_timeline</a>
	 * @param keyword L[[h
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return w肵L[[h̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getKeywordTimeline(String keyword, int page, int count, Date since) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(URL_KEYWORD_TIMELINE + URLEncoder.encode(keyword, Const.UTF8) + Const.EXT_XML, param);
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	/**
	 * 摜܂ލŐṼGg̃pubN^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @return 摜܂ލŐṼGg̃pubN^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline() throws HatenaHaikuException {
		return getAlbumTimeline(0, 0, null);
	}

	/**
	 * 摜܂ލŐṼGg̃pubN^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @param page 擾y[WłBő吔100łB
	 * @return 摜܂ލŐṼGg̃pubN^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline(int page) throws HatenaHaikuException {
		return getAlbumTimeline(page, 0, null);
	}

	/**
	 * 摜܂ލŐṼGg̃pubN^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return 摜܂ލŐṼGg̃pubN^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline(int page, int count) throws HatenaHaikuException {
		return getAlbumTimeline(page, count, null);
	}

	/**
	 * 摜܂ލŐṼGg̃pubN^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return 摜܂ލŐṼGg̃pubN^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline(int page, int count, Date since) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(URL_ALBUM_TIMELINE_XML, param);
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * w肵L[[h̉摜܂ލŐṼGg̃L[[h^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @return 摜܂ލŐṼGg̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline(String keyword) throws HatenaHaikuException {
		return getAlbumTimeline(keyword, 0, 0, null);
	}

	/**
	 * w肵L[[h̉摜܂ލŐṼGg̃L[[h^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @return 摜܂ލŐṼGg̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline(String keyword, int page) throws HatenaHaikuException {
		return getAlbumTimeline(keyword, page, 0, null);
	}

	/**
	 * w肵L[[h̉摜܂ލŐṼGg̃L[[h^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @return 摜܂ލŐṼGg̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline(String keyword, int page, int count) throws HatenaHaikuException {
		return getAlbumTimeline(keyword, page, count, null);
	}

	/**
	 * w肵L[[h̉摜܂ލŐṼGg̃L[[h^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/album/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-album">statuses/album</a>
	 * @return 摜܂ލŐṼGg̃L[[h^CC
	 * @throws HatenaHaikuException
	 */
	public List<Status> getAlbumTimeline(String keyword, int page, int count, Date since) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(URL_ALBUM_TIMELINE + URLEncoder.encode(keyword, Const.UTF8) + Const.EXT_XML, param);
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	//-------------------------------------------------------------
	// Xe[^X֌W
	//-------------------------------------------------------------
	
	/**
	 * w肵Xe[^X擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/show/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-show">statuses/show</a>
	 * @param statusId Xe[^XID
	 * @return Xe[^X
	 * @throws HatenaHaikuException
	 */
	public Status getStatus(String statusId) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(URL_STATUS + statusId + Const.EXT_XML, null);
			return toStatus(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	//-------------------------------------------------------------
	// X^[֌W
	//-------------------------------------------------------------

	//-------------------------------------------------------------
	// [U^tH[֌W
	//-------------------------------------------------------------

	/**
	 * w肵[UtH[Ă郆[ŨXg100擾܂BiPy[Wځj<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends">statuses/friends</a>
	 * @param userId [UID
	 * @return w肵[UtH[Ă郆[ŨXgiPy[Wځj
	 * @throws HatenaHaikuException
	 */
	public List<User> getFollowingList(String userId) throws HatenaHaikuException {
		return getFollowingList(userId, 0);
	}

	/**
	 * w肵[UtH[Ă郆[ŨXg100擾܂Biwy[Wj<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends/<font color="red">[UID</font>.xml&page=<font color="red">y[W</font></i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends">statuses/friends</a>
	 * @param userId [UID
	 * @param page y[W
	 * @return w肵[UtH[Ă郆[ŨXgiwy[Wj
	 * @throws HatenaHaikuException
	 */
	public List<User> getFollowingList(String userId, int page) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			String resultXml = HttpUtil.doGet(URL_FOLLOWING_LIST + userId + Const.EXT_XML, param);
			return toUserList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	

	/**
	 * w肵[UtH[Ă郆[ŨXg擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/followers/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-followers">statuses/followers</a>
	 * @param userId [UID
	 * @return w肵[UtH[Ă郆[ŨXg
	 * @throws HatenaHaikuException
	 */
	public List<User> getFollowersList(String userId) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(URL_FOLLOWERS_LIST + userId + Const.EXT_XML, null);
			return toUserList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	

	/**
	 * w肵[U擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/friendships/show/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#friendships-show">friendships/show</a>
	 * @param userId [UID
	 * @return w肵[U
	 * @throws HatenaHaikuException
	 */
	public User getUser(String userId) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(URL_USER + userId + Const.EXT_XML, null);
			return toUser(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	//-------------------------------------------------------------
	// L[[h֌W
	//-------------------------------------------------------------


	/**
	 * zbgL[[h̃Xg擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/hot.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/hotkeywords">ڃL[[h</a>
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-hot">keywords/hot</a>
	 * @return zbgL[[h̃Xg
	 * @throws HatenaHaikuException
	 */
	public List<Keyword> getHotKeywordList() throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(URL_HOT_KEYWORD_LIST_XML, null);
			return toKeywordList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * L[[hXg擾܂BiPy[Wځj<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/list.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/keywords">L[[hXg</a>
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-list">keywords/list</a>
	 * @return L[[hXgiPy[Wځj
	 * @throws HatenaHaikuException
	 */
	public List<Keyword> getKeywordList() throws HatenaHaikuException {
		return getKeywordList(null, 1);
	}

	/**
	 * L[[hXg擾܂Biwy[Wj<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/list.xml?page=<font color="red">y[W</font></i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/keywords">L[[hXg</a>
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-list">keywords/list</a>
	 * @param page y[W
	 * @return@L[[hXgiwy[Wj
	 * @throws HatenaHaikuException
	 */
	public List<Keyword> getKeywordList(int page) throws HatenaHaikuException {
		return getKeywordList(null, page);
	}

	/**
	 * w肵[hɕvL[[hXg擾܂Biwy[Wj<br/>
	 * p[^?word=00, page=1ȂǂgB<br/>
	 * page̍ő吔100APIy[WɏĂ邪Aȏł擾ł悤łB<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/list.xml?word=<font color="red">[h</font>&page=<font color="red">y[W</font></i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/keywords">L[[hXg</a>
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-list">keywords/list</a>
	 * @param searchWord [h
	 * @param page y[W
	 * @return@L[[hXgiwy[Wj
	 * @throws HatenaHaikuException
	 */
	public List<Keyword> getKeywordList(String searchWord, int page) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setWord(searchWord);
			param.setPage(page);
			String resultXml = HttpUtil.doGet(URL_KEYWORD_LIST_XML, param);
			return toKeywordList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * w肵[UtH[ĂL[[h̃Xg擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/keywords/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-keywords">statuses/keywords</a>
	 * @param userId [UID
	 * @return@w肵[UtH[ĂL[[hXg
	 * @throws HatenaHaikuException
	 */
	public List<Keyword> getFollowingKeywordList(String userId) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(URL_FOLLOWING_KEYWORD_LIST + userId + Const.EXT_XML, null);
			return toKeywordList(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * w肵L[[h擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/show/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-show">keywords/show</a>
	 * @param keyword L[[h
	 * @return w肵L[[h
	 * @throws HatenaHaikuException
	 */
	public Keyword getKeyword(String keyword) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(URL_KEYWORD + URLEncoder.encode(keyword, Const.UTF8) + Const.EXT_XML, null);
			return toKeyword(XmlUtil.getRootElement(resultXml));

		} catch (UnsupportedEncodingException e) {
			throw new HatenaHaikuException("UnsupportedEncodingExceptionB", e);

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	//----------------------------------
	// ȉAϊ\bh
	//----------------------------------
	
	/**
	 * Xe[^XGgStatusɕϊ܂B
	 * 
	 * @param elemStatus Xe[^XGg
	 * @return Status
	 */
	protected Status toStatus(Element elemStatus) throws HatenaHaikuException {
		try {
			Status status = new Status();
			// Xe[^XID
			status.setStatusId(XmlUtil.getText(elemStatus, "id"));
			// 쐬
			status.setCreatedAt(DateUtil.toJSTDate(XmlUtil.getText(elemStatus, "created_at")));
			// Cɓ
			status.setFavorited(Integer.parseInt(XmlUtil.getText(elemStatus, "favorited")));
			// ԐMXe[^XID
			status.setInReplyToStatusId(XmlUtil.getText(elemStatus, "in_reply_to_status_id"));
			// ԐM惆[UID
			status.setInReplyToUserId(XmlUtil.getText(elemStatus, "in_reply_to_user_id"));
			// L[[h
			status.setKeyword(XmlUtil.getText(elemStatus, "keyword"));
			// N
			status.setLink(XmlUtil.getText(elemStatus, "link"));
			// \[XiNCAgj
			status.setSource(XmlUtil.getText(elemStatus, "source"));
			// ee
			if (status.isIdPage()) {
				status.setText(XmlUtil.getText(elemStatus, "text"));
			} else {
				// idy[WłȂꍇAtextɂ́uL[[h=vɂĂ̂ŁA菜
				status.setText(XmlUtil.getText(elemStatus, "text").substring(status.getKeyword().length() + 1));
			}
			// [U
			status.setUser(toUser(XmlUtil.getFirstChildElement(elemStatus, "user")));
			return status;
		} catch (ParseException e) {
			throw new HatenaHaikuException("", e);
		}
	}
	
	/**
	 * Xe[^XGg[gStatus񃊃Xgɕϊ܂B
	 * 
	 * @param elemStatuses Xe[^XGg[g
	 * @return Status񃊃Xg
	 */
	protected List<Status> toStatusList(Element elemStatuses) throws HatenaHaikuException {
		List<Status> statusList = new ArrayList<Status>();
		NodeList elemStatusList = elemStatuses.getElementsByTagName("status");
		for (int i = 0; i < elemStatusList.getLength(); i++) {
			statusList.add(toStatus((Element)elemStatusList.item(i)));
		}
		return statusList;
	}

	/**
	 * [UGgUserɕϊ܂B
	 * 
	 * @param elemUser [UGg
	 * @return User
	 */
	protected User toUser(Element elemUser) {
		User user = new User();
		// [U
		user.setName(XmlUtil.getText(elemUser, "name"));
		// tH[
		user.setFollowersCount(Integer.parseInt(XmlUtil.getText(elemUser, "followers_count")));
		// [UID
		user.setUserId(XmlUtil.getText(elemUser, "id"));
		// vtB[摜URL
		user.setProfileImageUrl(XmlUtil.getText(elemUser, "profile_image_url"));
		// \
		user.setScreenName(XmlUtil.getText(elemUser, "screen_name"));
		// [ŨGgy[WURL
		user.setUrl(XmlUtil.getText(elemUser, "url"));
		return user;
	}

	/**
	 * [UGg[gUser񃊃Xgɕϊ܂B
	 * 
	 * @param elemUsers [UGg[g
	 * @return User񃊃Xg
	 */
	protected List<User> toUserList(Element elemUsers) throws HatenaHaikuException {
		List<User> userList = new ArrayList<User>();
		NodeList elemUserList = elemUsers.getElementsByTagName("user");
		for (int i = 0; i < elemUserList.getLength(); i++) {
			userList.add(toUser((Element)elemUserList.item(i)));
		}
		return userList;
	}

	/**
	 * L[[hGgKeywordɕϊ܂B
	 * 
	 * @param elemKeyword L[[hGg
	 * @return Keyword
	 */
	protected Keyword toKeyword(Element elemKeyword) throws HatenaHaikuException {
		Keyword keyword = new Keyword();
		// e
		keyword.setEntryCount(Integer.parseInt(XmlUtil.getText(elemKeyword, "entry_count")));
		// tH[
		keyword.setFollowersCount(Integer.parseInt(XmlUtil.getText(elemKeyword, "followers_count")));
		// L[[hy[W̃N
		keyword.setLink(XmlUtil.getText(elemKeyword, "link"));
		// ֘AL[[h
		keyword.setRelatedKeywords(XmlUtil.getTextList(elemKeyword, "related_keywords"));
		// L[[h^Cg
		keyword.setTitle(XmlUtil.getText(elemKeyword, "title"));
		return keyword;
	}

	/**
	 * L[[hGg[gKeyword񃊃Xgɕϊ܂B
	 * 
	 * @param elemKeywords L[[hGg[g
	 * @return Keyword񃊃Xg
	 */
	protected List<Keyword> toKeywordList(Element elemKeywords) throws HatenaHaikuException {
		List<Keyword> keywordList = new ArrayList<Keyword>();
		NodeList elemKeywordList = elemKeywords.getElementsByTagName("keyword");
		for (int i = 0; i < elemKeywordList.getLength(); i++) {
			keywordList.add(toKeyword((Element)elemKeywordList.item(i)));
		}
		return keywordList;
	}
}
