package hatenahaiku4j.util;

import hatenahaiku4j.Const;
import hatenahaiku4j.HatenaHaikuException;
import hatenahaiku4j.LoginUser;
import hatenahaiku4j.QueryParameter;
import hatenahaiku4j.UpdateParameter;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;
import java.util.Map;

/**
 * HTTPNGXgɊւ郆[eBeBNX
 * 
 * @author fumokmm
 */
public class HttpUtil {
	/** METHOD */
	private static enum Method { POST, GET }
	/** NGXgvpeBFBASICF */
	protected static final String REQUEST_PROPERTY_AUTHORIZATION = "Authorization";
	
	/**
	 * Qbg܂B
	 * 
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @return X|X{fB̕
	 */
	public static String doGet(String url, QueryParameter param) throws HatenaHaikuException {
		return doGet(null, url, param);
	}

	/**
	 * Qbg܂B
	 * 
	 * @param loginUser OC[U
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @return X|X{fB̕
	 */
	public static String doGet(LoginUser loginUser, String url, QueryParameter param) throws HatenaHaikuException {
		HttpURLConnection urlconn = null; // RlNV
		try {
			urlconn = (HttpURLConnection) new URL(url).openConnection();
			urlconn.setRequestMethod(Method.GET.name());
			if (loginUser != null) {
				urlconn.setRequestProperty(REQUEST_PROPERTY_AUTHORIZATION, loginUser.toBasicAuthenticationString());
			}
			urlconn.setDoOutput(true);
			
			// |Xge̕\
			if (param != null) {
				param.outputPostInfo();
			}

			PrintWriter writer = new PrintWriter(urlconn.getOutputStream());
			if (param != null) {
				writer.write(param.toParameter());
			}
			writer.flush();
			writer.close();

			// X|X
			return getResponse(urlconn);

		} catch (MalformedURLException e) {
			System.out.println(urlconn.getRequestMethod() + " failure");
			throw new HatenaHaikuException("sURL`łB", e);

		} catch (IOException e) {
			System.out.println(urlconn.getRequestMethod() + " failure");
			throw new HatenaHaikuException("IOException܂B", e);

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}

	/**
	 * |Xg܂B
	 * 
	 * @param loginUser OC[U
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @return X|X{fB̕
	 */
	public static String doPost(LoginUser loginUser, String url, UpdateParameter param) throws HatenaHaikuException {
		HttpURLConnection urlconn = null; // RlNV
		try {
			urlconn = (HttpURLConnection) new URL(url).openConnection();
			urlconn.setRequestMethod(Method.POST.name());
			urlconn.setRequestProperty(REQUEST_PROPERTY_AUTHORIZATION, loginUser.toBasicAuthenticationString());
			// L[[hw̏ꍇ́AOC[UIDƂB
			if (param.getKeyword() == null || param.getKeyword().equals("")) {
				param.setKeyword(loginUser.getHatenaIdFormat());
			}
			urlconn.setDoOutput(true);
			
			// |Xge̕\
			param.outputPostInfo(loginUser);

			PrintWriter writer = new PrintWriter(urlconn.getOutputStream());
			// TODO 摜t@C𓊍e (file p[^w) ꍇ́Amultipart/form-data ŃGR[hĉB
			writer.write(param.toParameter(loginUser));
			writer.flush();
			writer.close();
			
			// X|X
			return getResponse(urlconn);

		} catch (MalformedURLException e) {
			System.out.println(urlconn.getRequestMethod() + " failure");
			throw new HatenaHaikuException("sURL`łB", e);

		} catch (IOException e) {
			System.out.println(urlconn.getRequestMethod() + " failure");
			throw new HatenaHaikuException("IOException܂B", e);

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}
	
	/**
	 * X|Xԋp܂B
	 * 
	 * @param urlconn@HTTPRlNV
	 * @return X|X{fB̕
	 */
	private static String getResponse(HttpURLConnection urlconn) throws HatenaHaikuException {
		try {
			// X|X
			Map<String, List<String>> headers = urlconn.getHeaderFields();
			for (Map.Entry<String, List<String>> entry : headers.entrySet()) {
				System.out.println(entry.getKey() + ": " + entry.getValue());
			}
			// {fB
			StringBuilder responseBody = new StringBuilder();
			BufferedReader responseReader = new BufferedReader(new InputStreamReader(urlconn.getInputStream(), Const.UTF8));
			String line;
			while((line = responseReader.readLine()) != null) {
				responseBody.append(line);
			}

			System.out.println("----------------");
			System.out.println("X|XR[h: " + urlconn.getResponseCode());
			System.out.println("X|XbZ[W: " + urlconn.getResponseMessage());
			System.out.println("----------------");
			System.out.println(urlconn.getRequestMethod() + " successfully");

			return responseBody.toString();

		} catch (UnsupportedEncodingException e) {
			System.out.println(urlconn.getRequestMethod() + " failure");
			throw new HatenaHaikuException("GR[fBOT|[gĂ܂B", e);

		} catch (IOException e) {
			System.out.println(urlconn.getRequestMethod() + " failure");
			throw new HatenaHaikuException("IOException܂B", e);

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}
}
